# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from fkie_multimaster_msgs/ROSMaster.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class ROSMaster(genpy.Message):
  _md5sum = "0789d85e02ce55a78b1df2459150a275"
  _type = "fkie_multimaster_msgs/ROSMaster"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """string name
# ROS Master URI
string uri
# The timestamp of the state of the remoter ROS master
time last_change
# The timestamp of the state of the remoter ROS master, without the changes maked while a synchronization.
time last_change_local
bool online
string discoverer_name
string monitoruri
"""
  __slots__ = ['name','uri','last_change','last_change_local','online','discoverer_name','monitoruri']
  _slot_types = ['string','string','time','time','bool','string','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,uri,last_change,last_change_local,online,discoverer_name,monitoruri

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ROSMaster, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.uri is None:
        self.uri = ''
      if self.last_change is None:
        self.last_change = genpy.Time()
      if self.last_change_local is None:
        self.last_change_local = genpy.Time()
      if self.online is None:
        self.online = False
      if self.discoverer_name is None:
        self.discoverer_name = ''
      if self.monitoruri is None:
        self.monitoruri = ''
    else:
      self.name = ''
      self.uri = ''
      self.last_change = genpy.Time()
      self.last_change_local = genpy.Time()
      self.online = False
      self.discoverer_name = ''
      self.monitoruri = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.uri
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4IB().pack(_x.last_change.secs, _x.last_change.nsecs, _x.last_change_local.secs, _x.last_change_local.nsecs, _x.online))
      _x = self.discoverer_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.monitoruri
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.last_change is None:
        self.last_change = genpy.Time()
      if self.last_change_local is None:
        self.last_change_local = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uri = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.uri = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.last_change.secs, _x.last_change.nsecs, _x.last_change_local.secs, _x.last_change_local.nsecs, _x.online,) = _get_struct_4IB().unpack(str[start:end])
      self.online = bool(self.online)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.discoverer_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.discoverer_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.monitoruri = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.monitoruri = str[start:end]
      self.last_change.canon()
      self.last_change_local.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.uri
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4IB().pack(_x.last_change.secs, _x.last_change.nsecs, _x.last_change_local.secs, _x.last_change_local.nsecs, _x.online))
      _x = self.discoverer_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.monitoruri
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.last_change is None:
        self.last_change = genpy.Time()
      if self.last_change_local is None:
        self.last_change_local = genpy.Time()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.uri = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.uri = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.last_change.secs, _x.last_change.nsecs, _x.last_change_local.secs, _x.last_change_local.nsecs, _x.online,) = _get_struct_4IB().unpack(str[start:end])
      self.online = bool(self.online)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.discoverer_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.discoverer_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.monitoruri = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.monitoruri = str[start:end]
      self.last_change.canon()
      self.last_change_local.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4IB = None
def _get_struct_4IB():
    global _struct_4IB
    if _struct_4IB is None:
        _struct_4IB = struct.Struct("<4IB")
    return _struct_4IB
